package cz.cvut.ok.kapo.paa.kybl;

import junit.framework.TestCase;

public class StateManipulatorTest extends TestCase {
	private Configuration c;
	private StateManipulator sg;
	
	/* (non-Javadoc)
	 * @see junit.framework.TestCase#setUp()
	 */
	@Override
	protected void setUp() throws Exception {
		super.setUp();
		c = new Configuration(5,4,7,4,3);
		sg = new StateManipulator(c);
	}

	/*
	 * Test method for 'cz.cvut.ok.kapo.paa.kybl.engines.StateGenerator.fill(State, int)'
	 */
	public void testFill() {
		State s = new State(2,4,2,5,7);
		sg.fill(s,1);
		int cap1 = c.getCapacities().getK1();
		assertEquals(cap1,s.getK1());
		assertEquals(cap1,s.getKybl(1));

		sg.fill(s,5);
		int cap5 = c.getCapacities().getK5();
		assertEquals(cap5,s.getK5());
		assertEquals(cap5,s.getKybl(5));
		
		assertEquals(false,sg.fill(s,5));
	}

	/*
	 * Test method for 'cz.cvut.ok.kapo.paa.kybl.engines.StateGenerator.empty(State, int)'
	 */
	public void testEmpty() {
		State s = new State(2,4,2,5,7);
		sg.empty(s,1);
		assertEquals(0,s.getK1());
		assertEquals(0,s.getKybl(1));

		sg.empty(s,5);
		assertEquals(0,s.getK5());
		assertEquals(0,s.getKybl(5));

		assertEquals(false,sg.empty(s,5));
	}

	/*
	 * Test method for 'cz.cvut.ok.kapo.paa.kybl.engines.StateGenerator.pour(State, int, int)'
	 */
	public void testPour() {
		State s = new State(1,2,3,4,3);
		sg.pour(s,1,2);	//1,2 -> 0,3
		assertEquals(0,s.getK1());
		assertEquals(3,s.getK2());
		
		s = new State(1,2,3,4,3);
		sg.pour(s,5,3);
		sg.pour(s,4,3);// vysledek: 1,2,7,3,0
		assertEquals(1,s.getK1());
		assertEquals(2,s.getK2());
		assertEquals(7,s.getK3());
		assertEquals(3,s.getK4());
		assertEquals(0,s.getK5());
		
		assertEquals(false, sg.pour(s,1,3));
		assertEquals(false, sg.pour(s,5,1));
	}

}
