package cz.cvut.ok.kapo.paa.kybl;


/**
 * Trida reprezentuje konfiguraci. 5-ti rozmerne
 * pole uzlu, ktere reprezentuje stavovy prostor.
 * @author karel
 *
 */
public class StateSpace {
	// 5 kyblu, 5-ti rozmerne pole
	private Node[][][][][] stateSpace;
	private Configuration configuration;
	
	/**
	 * k1 - k5 oznacuje kapacitu jednotlivych kyblu.
	 */
	public StateSpace(Configuration conf) {
		super();
		this.configuration=conf;
		State cap = conf.getCapacities();
		this.stateSpace = new Node[cap.getK1()+1][cap.getK2()+1][cap.getK3()+1][cap.getK4()+1][cap.getK5()+1];
	}
	/**
	 * @return Returns the stateSpace.
	 */
	public Node[][][][][] getStateSpace() {
		return stateSpace;
	}

	/**
	 * @return Returns the endState.
	 */
	public State getEndState() {
		return configuration.getEndState();
	}

	/**
	 * @return Returns the startState.
	 */
	public State getStartState() {
		return configuration.getStartState();
	}

	/**
	 * @return Returns the endNode.
	 */
	public Node getEndNode() {
		State endState = configuration.getEndState();
		return stateSpace[endState.getK1()][endState.getK2()][endState.getK3()][endState.getK4()][endState.getK5()];
	}

	/**
	 * @return Returns the startNode.
	 */
	public Node getStartNode() {
		State startState = configuration.getStartState();
		return stateSpace[startState.getK1()][startState.getK2()][startState.getK3()][startState.getK4()][startState.getK5()];
	}

	/**
	 * @return Returns the Node.
	 */
	public Node getNode(State state) {
		return stateSpace[state.getK1()][state.getK2()][state.getK3()][state.getK4()][state.getK5()];
	}

	/**
	 * @return Returns the startNode.
	 */
	public void setNode(State state, Node node) {
		stateSpace[state.getK1()][state.getK2()][state.getK3()][state.getK4()][state.getK5()]=node;
	}

}
