/**
 * 
 */
package cz.cvut.ok.kapo.paa.kybl.engines;

import java.util.List;

import cz.cvut.ok.kapo.paa.kybl.Configuration;
import cz.cvut.ok.kapo.paa.kybl.Node;
import cz.cvut.ok.kapo.paa.kybl.StateSpace;



/**
 * Trida jako predloha pro ostatni enginy.
 * @author karel
 *
 */
public abstract class Engine {
	protected Configuration configuration;
	protected StateSpace stateSpace;
	protected boolean pathExist;	//nastavuje metoda execute()
	
	/**
	 * Vytvori engine.
	 */
	public Engine(Configuration config) {
		super();
		this.configuration = config;
		this.stateSpace = new StateSpace(configuration);
		this.pathExist=false;
	}
	
	/**
	 * @return Returns the conf.
	 */
	public Configuration getConfiguration() {
		return configuration;
	}
	
	/**
	 * @return Returns the stateSpace.
	 */
	protected StateSpace getStateSpace(){
		return stateSpace;
	}
	
	/**
	 * Vrati true, pokud se podarilo najit cestu.
	 */
	public boolean existPath(){
		return pathExist;
	}

	/**
	 * Tuto metodu pretizit. Provadi vlastni vypocet.
	 */
	public abstract void execute();

	/**
	 * Vrati cestu od startu do endu jako seznam. Prvni je start uzel.
	 */
	public abstract List<Node> getPath();

	
}
