package cz.cvut.ok.kapo.paa.kybl.engines.dh;

import cz.cvut.ok.kapo.paa.kybl.State;

public class DeltaHeuristicState extends State implements Comparable {
	private int rank;
	
	public DeltaHeuristicState(int k1, int k2, int k3, int k4, int k5) {
		super(k1, k2, k3, k4, k5);
		this.rank=0;
	}

	public DeltaHeuristicState(State orig, int rank) {
		super(orig.getK1(), orig.getK2(),orig.getK3(),orig.getK4(),orig.getK5());
		this.rank=rank;
	}

	/**
	 * @return Returns the rank.
	 */
	public int getRank() {
		return rank;
	}

	/**
	 * @param rank The rank to set.
	 */
	public void setRank(int rank) {
		this.rank = rank;
	}

	/**
	 * Porovna 2 stavy. Porovnava pole Ranku nastaveneho metodou setRank.
	 * Nutno nastavit externe. Pouziva se jako priorita pro prioritni frontu.
	 */
	public int compareTo(Object arg0) {
		return new Integer(this.getRank()).compareTo(new Integer( ((DeltaHeuristicState)arg0).getRank() ));
	}
	
	/**
	 * Vytvori klon objektu a vrati ho.
	 */
	@Override
	public DeltaHeuristicState clone(){
		DeltaHeuristicState st = new DeltaHeuristicState(getK1(),getK2(),getK3(),getK4(),getK5());
		st.setRank(this.getRank());
		return st;
	}

}
