package cz.cvut.ok.kapo.paa.kybl.tester;

import java.io.StringWriter;
import java.util.List;

import cz.cvut.ok.kapo.paa.kybl.Configuration;
import cz.cvut.ok.kapo.paa.kybl.Node;
import cz.cvut.ok.kapo.paa.kybl.engines.Engine;
import cz.cvut.ok.kapo.paa.kybl.engines.bfs.BFSEngine;
import cz.cvut.ok.kapo.paa.kybl.engines.dh.DHEngine;
import cz.cvut.ok.kapo.paa.kybl.utils.PathPrinter;

/**
 * Trida otestuje instance kyblu.
 * @author karel
 *
 */
public class KyblTester {

	public KyblTester() {
		super();
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		StringWriter sw;
		List<Node> l;
		Configuration [] confs = new Configuration[4];
		confs[0]=new Configuration(14,10,6,2,8); confs[0].setEndState(12,6,4,1,8); confs[0].setStartState(0,0,1,0,0);
		confs[1]=new Configuration(14,10,6,2,8); confs[1].setEndState(14,4,5,0,4); confs[1].setStartState(0,0,1,0,0);
		confs[2]=new Configuration(14,10,6,2,8); confs[2].setEndState(12,6,6,2,4); confs[2].setStartState(0,0,1,0,0);
		confs[3]=new Configuration(14,10,6,2,8); confs[3].setEndState(0,2,1,2,8); confs[3].setStartState(0,0,1,0,0);
		int i=1;
		for (Configuration c: confs){
			System.out.println("============ "+ i++ +"==========");
			System.out.println("DFSEngine: ");
			Engine eng = new BFSEngine(c);
			eng.execute();
			if (eng.existPath()){
				sw = new StringWriter();
				l = eng.getPath();
				PathPrinter.printPath(c,l,sw);
				System.out.println(sw.toString());
			}
			
			System.out.println("DHEngine: ");
			eng = new DHEngine(c);
			eng.execute();
			if (eng.existPath()){
				sw = new StringWriter();
				l = eng.getPath();
				PathPrinter.printPath(c,l,sw);
				System.out.println(sw.toString());
			}
		}

		System.out.println("|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||");

		Configuration [] confs1 = new Configuration[5];
		confs1[0]=new Configuration(15,12,8,4,6); confs1[0].setEndState(5,5,5,0,1); confs1[0].setStartState(0,0,0,0,0);
		confs1[1]=new Configuration(15,12,8,4,6); confs1[1].setEndState(12,1,3,4,5); confs1[1].setStartState(0,0,0,0,0);
		confs1[2]=new Configuration(15,12,8,4,6); confs1[2].setEndState(11,1,3,4,5); confs1[2].setStartState(0,0,0,0,0);
		confs1[3]=new Configuration(15,12,8,4,6); confs1[3].setEndState(3,12,4,0,6); confs1[3].setStartState(0,0,0,0,0);
		confs1[4]=new Configuration(15,12,8,4,6); confs1[4].setEndState(2,0,4,3,6); confs1[4].setStartState(0,0,0,0,0);
		i=1;
		for (Configuration c: confs1){
			System.out.println("============ "+ i++ +"==========");
			System.out.println("DFSEngine: ");
			Engine eng = new BFSEngine(c);
			eng.execute();
			if (eng.existPath()){
				sw = new StringWriter();
				l = eng.getPath();
				PathPrinter.printPath(c,l,sw);
				System.out.println(sw.toString());
			}

			System.out.println("DHEngine: ");
			eng = new DHEngine(c);
			eng.execute();
			if (eng.existPath()){
				sw = new StringWriter();
				l = eng.getPath();
				PathPrinter.printPath(c,l,sw);
				System.out.println(sw.toString());
			}
		}

		System.out.println("|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||");

		Configuration [] confs2 = new Configuration[6];
		confs2[0]=new Configuration(14,10,12,3,8); confs2[0].setEndState(13,9,12,2,7); confs2[0].setStartState(0,0,0,0,0);
		confs2[1]=new Configuration(14,10,12,3,8); confs2[1].setEndState(1,5,5,3,4); confs2[1].setStartState(0,0,0,0,0);
		confs2[2]=new Configuration(14,10,12,3,8); confs2[2].setEndState(0,9,5,3,1); confs2[2].setStartState(0,0,0,0,0);
		confs2[3]=new Configuration(14,10,12,3,8); confs2[3].setEndState(12,0,12,0,2); confs2[3].setStartState(0,0,0,0,0);
		confs2[4]=new Configuration(14,10,12,3,8); confs2[4].setEndState(7,3,7,0,0); confs2[4].setStartState(0,0,0,0,0);
		confs2[5]=new Configuration(14,10,12,3,8); confs2[5].setEndState(7,0,7,0,7); confs2[5].setStartState(0,0,0,0,0);
		i=1;
		for (Configuration c: confs2){
			System.out.println("============ "+ i++ +"==========");
			System.out.println("DFSEngine: ");
			Engine eng = new BFSEngine(c);
			eng.execute();
			if (eng.existPath()){
				sw = new StringWriter();
				l = eng.getPath();
				PathPrinter.printPath(c,l,sw);
				System.out.println(sw.toString());
			}

			System.out.println("DHEngine: ");
			eng = new DHEngine(c);
			eng.execute();
			if (eng.existPath()){
				sw = new StringWriter();
				l = eng.getPath();
				PathPrinter.printPath(c,l,sw);
				System.out.println(sw.toString());
			}
		}
	}

}
