/**
 * trida, ktera obsahuje metodu umejici vytisknout do zadaneho 
 * writeru obsazenou cestu.
 */
package cz.cvut.ok.kapo.paa.kybl.utils;

import java.io.IOException;
import java.io.Writer;
import java.util.List;

import cz.cvut.ok.kapo.paa.kybl.Configuration;
import cz.cvut.ok.kapo.paa.kybl.Node;
import cz.cvut.ok.kapo.paa.kybl.OpCodes;
import cz.cvut.ok.kapo.paa.kybl.State;
import cz.cvut.ok.kapo.paa.kybl.StateManipulator;

/**
 * 
 * @author karel
 *
 */
public class PathPrinter {

	/**
	 * 
	 */
	public PathPrinter() {
		super();
	}
	
	/**
	 * Vytiskne do Writeru out cestu obsazenou v nodu startNode, kde pocatecni stav je 
	 * ve startState. 
	 * @param startState
	 * @param startNode
	 * @param out
	 */
	public static void printPath(Configuration conf, List<Node> path, Writer out){
		State s1;
		State startState = conf.getStartState();
		StateManipulator sm = new StateManipulator(conf);
		s1 = startState.clone();
		try {
			out.write("Path length: "+(path.size()-1)+"\r\n");
			for (Node work: path){
				StringBuffer str = new StringBuffer();
				str.append(s1.toString());
				str.append(" -> ");
				sm.applyOperation(s1,work);
				str.append(s1.toString());
				out.write(str.toString()+"OpCode: "+OpCodes.getOpName(work.getOpcode())+" src("+work.getSrcKybl()+") dst("+work.getDstKybl()+")\r\n");
			}
		}
		catch (IOException ex){
			System.out.println("Chyba pri vypisovani cesty!"+ex.getMessage());
			ex.printStackTrace();
		}
	}

}
